#!/bin/bash
PLECO_NEWLINE=$(echo -e "\uEAB1")
PLECO_BOLD_OPEN=$(echo -e "\uEAB2")
PLECO_BOLD_CLOSE=$(echo -e "\uEAB3")
PLECO_ITALIC_OPEN=$(echo -e "\uEAB4")
PLECO_ITALIC_CLOSE=$(echo -e "\uEAB5")
PLECO_ALTFONT_OPEN=$(echo -e "\uEABE")
PLECO_ALTFONT_CLOSE=$(echo -e "\uEABF")
PLECO_BLOCK_OPEN=$(echo -e "\uEAC3")
PLECO_BLOCK_CLOSE=$(echo -e "\uEAC4")
PLECO_LINK_OPEN=$(echo -e "\uEAB8")
PLECO_LINK_CLOSE=$(echo -e "\uEABB\u200B")

header(){
	echo -n "$Simplified[$Traditional]	$Pronounciation	$*"
}

block(){
	echo -n $PLECO_BLOCK_OPEN"  @ "
	echo -n $1" "
	shift 1
	echo -n $*
	echo -n $PLECO_BLOCK_CLOSE
}

trailer(){
	echo
}

bold(){
        echo -n $PLECO_BOLD_OPEN
        echo -n $*
        echo -n $PLECO_BOLD_CLOSE
}

italic(){
	echo -n $PLECO_ITALIC_OPEN
	echo -n $*
	echo -n $PLECO_ITALIC_CLOSE
}

altfont(){
	echo -n $PLECO_ALTFONT_OPEN
	echo -n $*
	echo -n $PLECO_ALTFONT_CLOSE
}

make_links(){
OLDIFS=$IFS
IFS=" "
sep=false
for hw in $(echo $* | tr ';' ' '); do
	if $sep; then
		echo -n '; '
	fi
	echo -n $PLECO_LINK_OPEN
	echo -n $hw
	echo -n $PLECO_LINK_CLOSE
	sep=true
done
IFS=$OLDIFS
}

chengzi() {
while read ID Simplified Name Pronounciation Keyword_DE Keyword_EN Explaination Words_Examples Character_Examples Amount Typ Traditional; do
	header $ID
	block  $(altfont "Name") $Name
	block  $(altfont "Keyword") $(bold "DE") $Keyword_DE $(bold "EN") $Keyword_EN
	block  $(altfont "Explaination") $Explaination
	block  $(altfont "Words Examples") $(make_links $Words_Examples)
	block  $(altfont "Character Examples") $(make_links $Character_Examples)
	block  $(altfont "Amount") $Amount
	block  $(altfont "Typ") $Typ
	trailer
done
}

feizi(){
while read ID Simplified Name Pronounciation Pronounciation_2 Keyword_DE Keyword_EN Explaination Character_Examples Amount_Strokes Amount; do
	header $ID
	block  $(altfont "Name") $Name
	block  $(altfont "Keyword") $(bold "DE") $Keyword_DE $(bold "EN") $Keyword_EN
	block  $(altfont "Explaination") $Explaination
	block  $(altfont "Character Examples") $Character_Examples
	block  $(altfont "Amount Strokes") $Amount
	block  $(altfont "Amount") $Amount
	trailer
done
}

zhiwaidechengzi(){
while read ID Simplified Amount	Character_Examples Pronounciation Keyword_DE Keyword_EN Explaination Typ Traditional; do
	header $ID
	block  $(altfont "Keyword") $(bold "DE") $Keyword_DE $(bold "EN") $Keyword_EN
	block  $(altfont "Explaination") $Explaination
	block  $(altfont "Character Examples") $Character_Examples
	block  $(altfont "Amount") $Amount
	block  $(altfont "Typ") $Typ
	trailer
done
}

IFS="~"
tail -n +2 "bujian-final-800甲级字中成字部件.txt" | tr '	' "$IFS" | chengzi
tail -n +2 "bujian-final-800甲级字中的非字部件.txt" | tr '	' "$IFS" | feizi
tail -n +2  "bujian-final-800甲级字之外的成字部件.txt" | tr '	' "$IFS" | zhiwaidechengzi
